- name: 'Look at event data available to the "runner_on_ok" callback'
  ansible.builtin.debug:
    msg: ""
  vars:
    ansible_callback_diy_playbook_on_task_start_msg: "\nDIY output(via task vars): task example: {{ ansible_callback_diy.task.name }}"
    ansible_callback_diy_runner_on_ok_msg: |2+
      {% for key in ansible_callback_diy | sort %}
      {{ green }}{{ key }}:
        {{ white }}{{ ansible_callback_diy[key] }}

      {% endfor %}

- name: "preparing environment"
  set_fact:
    in_ci: "{{ in_ci | default(False) }}"
    stack_dir: "{{ stack_dir | default(lookup('env', 'STACK_DIR') ) }}"

- name: "stack directory"
  assert:
    that:
      - stack_dir != ""
    fail_msg: "MISSING. Please use --stack to specify a stack directory"
    success_msg: "{{ stack_dir }}"

- name: "detecting cloudstack config file"
  set_fact:
    cloudstack_config: "{{ lookup('env', 'CLOUDSTACK_CONFIG') | default(stack_dir + '/acs.yml', true) }}"

- name: "cloudstack config file"
  debug:
    msg: "{{ cloudstack_config }}"
    verbosity: 2

- name: "loading user config"
  include_vars:
    file: "{{ cloudstack_config }}"
    name: cloudstack
  failed_when: False

- name: "cloudstack config"
  debug:
    msg: "{{ cloudstack | to_nice_json }}"
    verbosity: 2

- name: "checking SSH keys"
  block:
    - name: "validating SSH config"
      assert:
        that:
          - cloudstack.plugins.ssh.config['keys']['private'] != ""
        msg: "SSH private key must be set"

    - name: "setting active SSH key"
      set_fact:
        ansible_ssh_private_key_file: "{{ stack_dir }}/{{ cloudstack.plugins.ssh.config['keys']['private'] }}"
  when: cloudstack.kaas.enabled|bool

- name: "detecting ingress protocol (TLS)"
  set_fact:
    ingress_protocol: "https"
  when: cloudstack.stack.tls|bool
  no_log: true

- name: "detecting ingress protocol"
  set_fact:
    ingress_protocol: "http"
  when: not cloudstack.stack.tls|bool
  no_log: true

- name: "ingress protocol"
  debug:
    msg: "{{ ingress_protocol }}"
